#include "Utilities.jsx"
#include "json2.js"

function isFontActivated(font)
{
    var returnObject = null;
    app.updateFonts();
    var fonts = app.fonts.everyItem().getElements();
    for (var i = 0; i < fonts.length; ++i)
    {
        if (fonts[i].postscriptName == font.name)
        {
            returnObject = {isActivated: true, fontID: font.id};
            break;
        }
    }
    
    if(returnObject == null)
    {
        returnObject = {isActivated: false, fontID: font.id};
    }

    return JSON.stringify(returnObject);
}
		
function applyFont(fontObject)
{
    var returnObject = {succeeded: false};
    
    try 
    {
        if (!app.activeDocument.activeLayer.locked)
        {
            var font = null;
            if ( fontObject.fontName != null )
            {
                // Find the font object that matches our PostScript name.
                var fonts = app.fonts.everyItem().getElements();
                for (var i = 0; i < fonts.length; ++i)
                {
                    if (postScriptNamesMatch(fonts[i].postscriptName, fontObject.fontName))
                    {
                        font = fonts[i];
                        break;
                    }
                }
            }
        
            if (font != null)
            {
                for (var i = 0; i < app.activeDocument.selection.length; ++i)
                {
                    try
                    {
                        var text = app.activeDocument.selection[i];
                        
                        switch(text.constructor.name)
                        {
                            case "InsertionPoint":
                            case "Character":
                            case "Word":
                            case "TextStyleRange":
                            case "Line":
                            case "Paragraph":
                            case "TextColumn":
                            case "Text":
                            case "Story":
                                text.appliedFont = font;
                                returnObject = {succeeded: true};
                                break;
                                
                            case "TextFrame":
                                for (var idx = 0; idx < text.texts.length; ++idx)
                                {
                                    text.texts[idx].appliedFont = font;
                                }
                                returnObject = {succeeded: true};
                                break;
                                
                            default:
                                // Not a text object
                                break;
                        }							
                    }
                    catch (error)
                    {							
                    }
                }
            }
         }
    }
    catch(error)
    {
    }

    return JSON.stringify(returnObject);
}