/**
 * Handle replication progress events
 */


function bulkReplicationProgressHandler(text, step, numSteps)
{
    panel.progress.setProgressInfo(panel.progress.bulkReplicationProgressInfo, text, step, numSteps, true);
    

    if(panel.dropDownMenu.savedSmartListID != SmartListIDs.kGoogle &&
       panel.dropDownMenu.savedSmartListID != SmartListIDs.kTypekit &&
       panel.dropDownMenu.savedSmartListID != SmartListIDs.kSystemFonts)
    {
        panel.progress.updateProgress(ProgressTitle.kSynchronizeUTS, panel.progress.bulkReplicationProgressInfo);
    }
}

function bulkReplicationStoppedHandler()
{
    panel.progress.setProgressInfo(panel.progress.bulkReplicationProgressInfo, null, null, null, false);
    panel.progress.hideProgress();

    panel.reloadData();
}


function incrementalReplicationProgressHandler(text, step, numSteps)
{
    panel.progress.setProgressInfo(panel.progress.incrementalReplicationProgressInfo, text, step, numSteps, true);
}

function incrementalReplicationStoppedHandler()
{
    panel.progress.setProgressInfo(panel.progress.incrementalReplicationProgressInfo, null, null, null, false);

    panel.reloadData();
}


function fontServerReplicationProgressHandler(text, step, numSteps)
{
    panel.progress.setProgressInfo(panel.progress.fontServerReplicationProgressInfo, text, step, numSteps, true);
}

function fontServerReplicationStoppedHandler()
{
    panel.progress.setProgressInfo(panel.progress.fontServerReplicationProgressInfo, null, null, null, false);

    panel.reloadData();
}


function googleReplicationProgressHandler(text, step, numSteps)
{
    panel.progress.setProgressInfo(panel.progress.googleProgressInfo, text, step, numSteps, true);
    
    if(panel.dropDownMenu.savedSmartListID == SmartListIDs.kGoogle)
    {
        panel.progress.updateProgress(ProgressTitle.kSynchronizeGoogle, panel.progress.googleProgressInfo);
    }
    
}

function googleReplicationStoppedHandler()
{
    panel.progress.setProgressInfo(panel.progress.googleProgressInfo, null, null, null, false);
    panel.progress.hideProgress();

    // Reload the font list if it's showing
    if(panel.dropDownMenu.savedSmartListID == SmartListIDs.kGoogle)
    {
        panel.fontList.reload();
    }
}
