function MessageSender()
{

    this.sendMessageObject = function(messageObject)
    {
        var message = JSON.stringify(messageObject);
        var event = new CSEvent("com.extensis.PanelToPlugin", "APPLICATION",
                "PHXS", "com.extensis.HTMLPanel");
        event.data = message;
        new CSInterface().dispatchEvent(event);
    };

    this.requestStartPanelInfo = function()
    {
        var messageObject = new Object();
        messageObject[MessageKey.kMessageIDKey] = MessageID.kStartPanel;
        this.sendMessageObject(messageObject);
    };
        
    this.createSmartList = function()
    {
        var messageObject = new Object();
        messageObject[MessageKey.kMessageIDKey] = MessageID.kCreateSmartList;
        messageObject[MessageKey.kSmartListNameKey] = localizeString("UntitledSmartList");
        
        this.sendMessageObject(messageObject);        
    };
    
    this.deleteSmartList = function(smartListID)
    {
        var messageObject = new Object();
        messageObject[MessageKey.kMessageIDKey] = MessageID.kDeleteSmartList;
        messageObject[MessageKey.kSmartListIDKey] = smartListID;
        this.sendMessageObject(messageObject);        
    };
    
    this.getSmartListFonts = function(smartListID)
    {
        var messageObject = new Object();
        messageObject[MessageKey.kMessageIDKey] = MessageID.kGetSmartListFonts;
        messageObject[MessageKey.kSmartListIDKey] = smartListID;
        
        this.sendMessageObject(messageObject);
    };

    this.deleteTempFile = function(filename)
    {
        var messageObject = new Object();
        messageObject[MessageKey.kMessageIDKey] = MessageID.kDeleteFile;
        messageObject[MessageKey.kFilenameKey] = filename;
        
        this.sendMessageObject(messageObject);
    };
    
    this.getFontPNGs = function(allFontIDs, highPriorityFontIDs, smartListID)
    {
        var messageObject = new Object();
        messageObject[MessageKey.kMessageIDKey] = MessageID.kGetFontPNG;
        messageObject[MessageKey.kFontIDsKey] = allFontIDs;
        messageObject[MessageKey.kHighPriorityFontIDsKey] = highPriorityFontIDs;
        messageObject[MessageKey.kSmartListIDKey] = smartListID;
        
        this.sendMessageObject(messageObject);
    };
    
    this.activateFont = function(fontID, postscriptName, displayName)
    {
        var messageObject = new Object();
        messageObject[MessageKey.kMessageIDKey] = MessageID.kDesignActivateFamilyForFont;
        
        messageObject[MessageKey.kFontIDKey] = fontID;
        messageObject[MessageKey.kPostscriptNameKey] = postscriptName;
        messageObject[MessageKey.kDisplayNameKey] = displayName;
        
        this.sendMessageObject(messageObject);
    };
    
    this.getAllSmartLists = function()
    {
        var messageObject = new Object();
        
        messageObject[MessageKey.kMessageIDKey] = MessageID.kGetAllSmartLists;
        
        this.sendMessageObject(messageObject); 
    };
    
    this.getDropDownSelection = function()
    {
        var messageObject = new Object();
        
        messageObject[MessageKey.kMessageIDKey] = MessageID.kGetDropDownSelection;
        
        this.sendMessageObject(messageObject); 
    };
    
    this.saveDropDownSelection = function(selection)
    {
        var messageObject = new Object();
        
        messageObject[MessageKey.kMessageIDKey] = MessageID.kSaveDropDownSelection;
        messageObject[MessageKey.kSelectionKey] = selection;
        messageObject[MessageKey.kSavesSmartListKey] = true;
        
        this.sendMessageObject(messageObject);
    };
    
    this.areGoogleFontsEnabled = function()
    {
        var messageObject = new Object();
        
        messageObject[MessageKey.kMessageIDKey] = MessageID.kAreGoogleFontsEnabled;

        this.sendMessageObject(messageObject);
    };
    
    this.getUTSIsLoggedIn = function()
    {
        var messageObject = new Object();
        
        messageObject[MessageKey.kMessageIDKey] = MessageID.kUTSIsLoggedIn;

        this.sendMessageObject(messageObject);
    };
    
    this.getSmartListTree = function(smartListID)
    {
        var messageObject = new Object();
        
        messageObject[MessageKey.kMessageIDKey] = MessageID.kGetPanelSmartListTree;
        messageObject[MessageKey.kSmartListIDKey] = smartListID;

        this.sendMessageObject(messageObject);
    };
    
    this.setSmartListName = function(smartListID, name)
    {
        var messageObject = new Object();
        
        messageObject[MessageKey.kMessageIDKey] = MessageID.kSetSmartListName;
        messageObject[MessageKey.kSmartListIDKey] = smartListID;
        messageObject[MessageKey.kSmartListNameKey] = name;

        this.sendMessageObject(messageObject);
    };
    
    this.setSmartListQuery = function(smartListID, workgroupIDs, setIDs, smartSetIDs)
    {
        var messageObject = new Object();
        
        messageObject[MessageKey.kMessageIDKey] = MessageID.kSetSmartListQuery;
        messageObject[MessageKey.kSmartListIDKey] = smartListID;
        messageObject[MessageKey.kWorkgroupIDsKey] = workgroupIDs;
        messageObject[MessageKey.kSetIDsKey] = setIDs;
        messageObject[MessageKey.kSmartSetIDsKey] = smartSetIDs;
                
        this.sendMessageObject(messageObject);
    };
    
    this.sendHostAppKeyPress = function(isCtrlPressed, isShiftPressed, isAltPressed, keyCode)
    {
        var messageObject = new Object();
        
        messageObject[MessageKey.kMessageIDKey] = MessageID.kSendHostAppKeyPress;
        messageObject[MessageKey.kIsCtrlPressedKey] = isCtrlPressed;
        messageObject[MessageKey.kIsShiftPressedKey] = isShiftPressed;
        messageObject[MessageKey.kIsAltPressedKey] = isAltPressed;
        messageObject[MessageKey.kKeyCodeKey] = keyCode;

        this.sendMessageObject(messageObject);
    };
}

panel.messageSender = new MessageSender();
