var duration = 400;

var hoverBubbleCount = 0;

var selectButtonTitle = "";

function setSelectButtonTitle(title)
{
    selectButtonTitle = title;

    recreateSelectButtons();

    $(".template").on("mouseenter", showHoverImage);
    $(".template").on("mouseleave", hideHoverImage);

    $(window).resize(function(event)
    {
        recreateSelectButtons();
    });
}

function recreateSelectButtons()
{
    $(".hover-bubble").remove();

    $(".template").each(function ()
    {
        var position = $(this).offset();

        var hoverBubble = document.createElement("div");
        $(hoverBubble).attr("id", "hover-bubble" + ++hoverBubbleCount);
        addClass($(hoverBubble), "hover-bubble");

        if (navigator.appName != "Microsoft Internet Explorer")
        {
            $(hoverBubble).corner("14px");
        }

        hoverBubble.appendChild(document.createTextNode(selectButtonTitle));

        $(this).append(hoverBubble);
        addClass($(hoverBubble), "hover-bubble");

        var y = ($(".template-image").height() - $(hoverBubble).height()) / 2;
        var x = ($(".template-image").width()  - $(hoverBubble).width())  / 2;
        $(hoverBubble).css("top", position.top + y);
        $(hoverBubble).css("left", position.left + x);

        $(hoverBubble).fadeTo(0, 0);
    });
}

function showHoverImage()
{
    $(this).children(".hover-bubble").stop(true, false);
    $(this).children(".hover-bubble").fadeTo(duration, 1);
    $(this).children(".template-image-container").addClass("image-container-border");
}

function hideHoverImage()
{
    $(this).children(".hover-bubble").stop(true, false);
    $(this).children(".hover-bubble").fadeTo(duration, 0);
    $(this).children(".template-image-container").removeClass("image-container-border");
}

function hideAllHoverImages()
{
    $(".hover-bubble").stop(true, false);
    $(".hover-bubble").fadeTo(duration, 0);
}

function goToTemplate(url)
{
    var result = window.open(url, "_self");
    return result != null;
}

function windowLostFocus()
{
    hideAllHoverImages();
}

function setBackgroundColor (color)
{
    // The picker does not allow the user to customize the page colors.
    // These functions are empty to avoid Javascript errors when calling them.
}

function setTextColor (color)
{
    // The picker does not allow the user to customize the page colors.
    // These functions are empty to avoid Javascript errors when calling them.
}

function showSplashScreen()
{
    $("#extensis-splash-screen").click(hideSplashScreen);

    $("#extensis-splash-screen").css("display", "block");
}

function hideSplashScreen()
{
    $("#grid").css("display", "block");
    $("#extensis-splash-screen").css("display", "none");
    recreateSelectButtons();
}
