// WebKit browsers interpret the coordinates passed to document.elementFromPoint
// as relative to the top of the viewport, whereas IE and Firefox interpret them
// as relative to the top of the document. We can detect whether we're using a
// WebKit browser by trying to get the point at the very edge of the viewport.
// http://www.icab.de/blog/2011/10/17/elementfrompoint-under-ios-5/

function windowGainedFocus(x, y)
{
    var isRelative = true;

    if ($(document).scrollTop() > 0)
    {
        isRelative = document.elementFromPoint(
            0,
            $(document).scrollTop() + $(window).height() - 1
        ) == null;
    }
    else if ($(document).scrollLeft() > 0)
    {
        isRelative = document.elementFromPoint(
            $(document).scrollLeft() + $(window.width) - 1,
            0
        ) == null;
    }

    if (!isRelative)
    {
        x += $(document).scrollLeft();
        y += $(document).scrollTop();
    }

    var element = document.elementFromPoint(x, y);

    $(element).mouseenter()
}
